﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Research.Kinect.Nui;
using Coding4Fun.Kinect.Wpf; 

namespace CameraFundamentals
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        //Kinect Runtime
        Runtime nui; 

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            SetupKinect(); 

        }

        private void SetupKinect()
        {
            if (Runtime.Kinects.Count == 0)
            {
                this.Title = "No Kinect connected";
            }
            else
            {
                //use first Kinect
                nui = Runtime.Kinects[0];

                //setup event handlers
                nui.VideoFrameReady += new EventHandler<ImageFrameReadyEventArgs>(nui_VideoFrameReady);
                
                //Initialize to return Color
                nui.Initialize(RuntimeOptions.UseColor);

                //open the streams
                nui.VideoStream.Open(ImageStreamType.Video, 2, ImageResolution.Resolution640x480, ImageType.Color);                
            }
        }

       

        void nui_VideoFrameReady(object sender, ImageFrameReadyEventArgs e)
        {
            //Manually create BitmapSource for Video
            PlanarImage imageData = e.ImageFrame.Image;
            image1.Source = BitmapSource.Create(imageData.Width, imageData.Height, 96, 96, PixelFormats.Bgr32, null, imageData.Bits, imageData.Width * imageData.BytesPerPixel);
            image2.Source = e.ImageFrame.ToBitmapSource();
            int offset = 0;
            Color[] bitmap = new Color[640 * 480];
            for (int y = 0; y < 480; y++)
            {
                for (int x = 0; x < 640; x++)
                {
                    Color c = new Color();
                    c.R = imageData.Bits[offset + 2];
                    c.G = imageData.Bits[offset + 1];
                    c.B = imageData.Bits[offset];
                    c.A = 255;
                    bitmap[y * 640 + x] = c;
                    offset += 4;
                }
            }
            
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            nui.Uninitialize(); 
        }
    }
}
